package gearman

import "fmt"

// Error implements a gearman client specific error
type Error struct {
	clientName string
	msg        string
	err        error
}

// Unwrap implements errors.Unwrap
func (e *Error) Unwrap() error {
	return e.err
}

// Unwrap implements errors.Error
func (e *Error) Error() string {
	if e.err != nil {
		if e.msg != "" {
			return fmt.Sprintf("[%s] gearman %s: %s", e.clientName, e.msg, e.err.Error())
		}
		return fmt.Sprintf("[%s] gearman client error: %s", e.clientName, e.err.Error())
	}
	return fmt.Sprintf("[%s] %s", e.clientName, e.msg)
}
