package gearman

import (
	"fmt"
	"testing"
)

func TestError(t *testing.T) {
	errMap := map[string]error{
		"[test] test":                       &Error{clientName: "test", msg: "test"},
		"[test] gearman test: test":         &Error{clientName: "test", err: fmt.Errorf("test"), msg: "test"},
		"[test] gearman client error: test": &Error{clientName: "test", err: fmt.Errorf("test")},
	}

	for expected, err := range errMap {
		if fmt.Sprint(err) != expected {
			t.Error("expected", expected, "but got", fmt.Sprint(err))
		}
	}
}
