package icinga

// The Config struct needs to match the json structure from the openITCOCKPIT database
type Config struct {
	Verbose                 bool
	ApiUrl                  string `json:"api_url"`      // API Endpoint. E.g.: https://icinga2.itsm.love:5665
	ApiUser                 string `json:"api_user"`     // User name for the API E.g.: "root"
	ApiPassword             string `json:"api_password"` // Password for the given user
	UseProxy                int    `json:"use_proxy"`    // Use a HTTP Proxy (0 or 1)
	ProxyAddress            string // Address of the HTTP Proxy to use (not from DB JSON string)
	IgnoreSslCertificate    int    `json:"ignore_ssl_certificate"`   // Do not verify the TLS Certificate for HTTPS connections (0 or 1)
	CheckType               string `json:"check_type"`               // What type of checks should be transferred ("CheckResult" or "StateChange")
	ReceiveDowntimes        int    `json:"receive_downtimes"`        // Synchronize downtimes from Icinga into openITCOCKPIT (one-way)
	ReceiveAcknowledgements int    `json:"receive_acknowledgements"` // Synchronize acknowledgements from Icinga into openITCOCKPIT (one-way)
}
