package icinga

import (
	"github.com/it-novum/event-collectd/oitc"
)

// https://github.com/Icinga/icinga2/blob/0d5802937ba274fd3b9e13a48c4638cc104ad577/lib/icinga/checkresult.ti#L14-L31
// https://icinga.com/docs/icinga-2/latest/doc/12-icinga2-api/#process-check-result
// It apears that Icinga2 has only two exit codes available
// 0=UP
// 1=DOWN
// There is no UNREACHABLE like Naemon has

// Rewrite all state codes !=0 to DOWN
func convertIcingaHoststatusToNaemon(state int64) int64 {
	if state == oitc.STATE_UP {
		return oitc.STATE_UP
	}

	return oitc.STATE_DOWN
}
