package main

import (
	"fmt"
	"os"

	"github.com/akamensky/argparse"
	"github.com/it-novum/event-collectd/cli"
)

func main() {

	args := &cli.CliArguments{}

	// Create new parser object
	parser := argparse.NewParser("event-collectd", "Event-Collectd querys external monitoring systems to pass check results to openITCOCKPIT")

	args.Verbose = parser.Flag("v", "verbose", &argparse.Options{Required: false, Help: "Enable verbose output and logging"})

	// Parse input
	err := parser.Parse(os.Args)
	if err != nil {
		// In case of error print error and print usage
		// This can also be done by passing -h or --help flags
		fmt.Print(parser.Usage(err))
	}

	cli.MainThreadLoop(args)
}
