package oitc

import (
	"context"
	"testing"
)

func TestConnect(t *testing.T) {
	ctx := context.Background()

	dbh, err := NewDatabase(ctx, "/opt/openitc/etc/mysql/mysql.cnf")
	if err != nil {
		t.Fatal(err)
	}
	defer dbh.Close()

	hosts, err := dbh.FetchHosts()

	if err != nil {
		t.Error(err)
	}

	if len(hosts) == 0 {
		t.Error("List of hosts from MySQL is empty")
	}

	services, err := dbh.FetchServices()

	if err != nil {
		t.Error(err)
	}

	if len(services) == 0 {
		t.Error("List of services from MySQL is empty")
	}

}
