package oitc

import "fmt"

// Hosts
const STATE_UP = 0
const STATE_DOWN = 1
const STATE_UNREACHABLE = 2

// Services
const STATE_OK = 0
const STATE_WARNING = 1
const STATE_CRITICAL = 2
const STATE_UNKNOWN = 3

// Makes sure the the status code is 0,1 or 2 for host check results
func InHostcheckBoundaries(state int64, hostname string) (int64, error) {
	if state >= STATE_UP && state <= STATE_UNREACHABLE {
		return state, nil
	}

	return STATE_UNREACHABLE, fmt.Errorf("return code of %v for check of host '%s' was out of bounds", state, hostname)
}

// Makes sure the the status code is 0,1,2 or 3 for service check results
func InServicecheckBoundaries(state int64, hostname, service_description string) (int64, error) {
	if state >= STATE_OK && state <= STATE_UNKNOWN {
		return state, nil
	}

	return STATE_UNKNOWN, fmt.Errorf("return code of %v for check of service '%s' on host '%s' was out of bounds", state, hostname, service_description)
}
